Last Comment Bug 644855 - Animated gifs that have finished animating don't restart when src is set
: Animated gifs that have finished animating don't restart when src is set
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: ImageLib (show other bugs)
: Trunk
: x86_64 Windows 7
: -- normal with 1 vote (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
: Milan Sreckovic [:milan]
Mentors:
http://www.sorting-algorithms.com/
Depends on: 641198
Blocks: 572520
  Show dependency treegraph
 
Reported: 2011-03-24 17:17 PDT by luke_strider
Modified: 2012-12-06 03:32 PST (History)
8 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description luke_strider 2011-03-24 17:17:17 PDT
User-Agent:       Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0) Gecko/20100101 Firefox/4.0
Build Identifier: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0) Gecko/20100101 Firefox/4.0

I'm not the site listed aboves admin / developer, so the javascript might be slightly odd, but I have noticed that since upgrading to 4.0 the Javascript does not seem to work as on this page as before.

Reproducible: Always

Steps to Reproduce:

1) Go to http://www.sorting-algorithms.com/
2) Click the "restart-all" button (the biggest green icon).
3) Watch and wait for all the sorting algorithms to finish
4) Click it again
5) Notice that it resets, but doesn't start them off again.


Expected Results:  
The expected behaviour (and the behaviour in the previous version of Firefox) would be every time you click the button for it to reset and start again from scratch.  Note: This is broken for all the green buttons.
Comment 1 luke_strider 2011-03-24 17:19:46 PDT
Just a quick note: In case it wasn't clear, this is on Firefox 4.0, not the trunk, although there doesn't seem to be a drop down for that version.
Comment 2 Matthias Versen [:Matti] 2011-03-24 18:45:00 PDT
I can confirm this with Seamonkey trunk and FF4.0 on win32.
Restarting works in Opera11 and the FF safemode doesn't help.
Seamonkey shows no errors in the error console.

JS Engine is just a guess, please don't throw stones at me if that is incorrect.
Comment 3 Alice0775 White 2011-03-24 19:12:33 PDT
Regression 1 window:
Works:
http://hg.mozilla.org/mozilla-central/rev/5f857be14db9
Mozilla/5.0 (Windows; Windows NT 6.1; WOW64; rv:2.0b3pre) Gecko/20100727 Minefield/4.0b3pre ID:20100728145944
Fails(image is not reset, don't re-run):
http://hg.mozilla.org/mozilla-central/rev/b8b62b351c09
Mozilla/5.0 (Windows; Windows NT 6.1; WOW64; rv:2.0b3pre) Gecko/20100728 Minefield/4.0b3pre ID:20100728152620
Pushlog:
http://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=5f857be14db9&tochange=b8b62b351c09
Triggered by:
Bug 572520 - make all imgIDecoderObserver notifications asynchronous


{
    Regression 2 window:
    Fails(image is not reset, don't re-run):
    http://hg.mozilla.org/mozilla-central/rev/e0ea4e4d401f
    Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0b10pre) Gecko/20110121 Firefox/4.0b10pre ID:20110121024721
    Fails(infinite loop):
    http://hg.mozilla.org/mozilla-central/rev/ac1ddab6de59
    Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0b10pre) Gecko/20110121 Firefox/4.0b10pre ID:20110121152914

    Fixed regression 2 window:
    Fails(infinite loop):
    http://hg.mozilla.org/mozilla-central/rev/bc2fda9a8b32
    Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0b10pre) Gecko/20110121 Firefox/4.0b10pre ID:20110123202459
    Fails(image is not reset, don't re-run):
    http://hg.mozilla.org/mozilla-central/rev/4e57b18dd908
    Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0b10pre) Gecko/20110123 Firefox/4.0b10pre ID:20110123203513
}

Pertially fixed regression 1:
Fails(image is not reset, don't re-run):
http://hg.mozilla.org/mozilla-central/rev/8149e1a06476
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0b11pre) Gecko/20110125 Firefox/4.0b11pre ID:20110126103957
Fails(image is reset, don't re-run)
http://hg.mozilla.org/mozilla-central/rev/908ae37abec8
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0b11pre) Gecko/20110126 Firefox/4.0b11pre ID:20110126110507
Pushlog:
http://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=8149e1a06476&tochange=908ae37abec8
Comment 4 Matthias Versen [:Matti] 2011-03-24 19:21:22 PDT
thanks Alice, the last regression window points to bug Bug 594771 , moving to imagelib
Comment 5 Boris Zbarsky [:bz] (still a bit busy) 2011-03-24 19:45:49 PDT
Alon?  The site is using animated gifs; it sounds like we're not properly restarting the animation on src set for some reason?
Comment 6 Boris Zbarsky [:bz] (still a bit busy) 2011-03-24 19:51:17 PDT
We do call ResetAnimation() on the image.  But mAnimationFinished is false, so ShouldAnimate() returns 0 and hence ResetAnimation() does absolutely nothing.
Comment 7 Boris Zbarsky [:bz] (still a bit busy) 2011-03-24 19:54:33 PDT
Looks a lot like bug 641198.
Comment 8 Boris Zbarsky [:bz] (still a bit busy) 2011-03-24 19:57:15 PDT
Yeah, the patch in bug 641198 fixes this.
Comment 9 Alice0775 White 2011-04-19 15:01:53 PDT
I can not reproduce any more
http://hg.mozilla.org/mozilla-central/rev/7d4eb3d3c9de
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:6.0a1) Gecko/20110419 Firefox/6.0a1 ID:20110419030537
http://hg.mozilla.org/mozilla-aurora/rev/6b33dec92aaa
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:5.0a2) Gecko/20110419 Firefox/5.0a2 ID:20110419042005
Comment 10 Alon Zakai (:azakai) 2011-04-19 15:15:57 PDT
Thanks for confirming, bug 641198 should indeed have fixed this.

Note You need to log in before you can comment on or make changes to this bug.